#include <p24fxxxx.h>
#include <timer.h>
#include <adc.h>
#include <pps.h>
#include <uart.h>
#include <stdio.h>
#include "APP026-3_LCM.h"

/* Configuration Settings */
// OSC Input = Primary with PLL , 8M / 2
// Debug Interface PGEC1, PGED1, Disable JTAG
// Disabld WDT, Clock Switch, Fail Safe Clock Monitor ,IO One Way.

// Oscillator ] Primary with PLL Mode, IESO_OFFC
_CONFIG2( POSCMOD_HS & IOL1WAY_OFF & FCKSM_CSDCMD & FNOSC_PRIPLL & PLLDIV_DIV2 & IESO_OFF ); 

// Debug ]Ĥ@, JTAGEN_OFFC
_CONFIG1( WDTPS_PS32768 & FWPSA_PR128 & WINDIS_OFF & FWDTEN_OFF & ICS_PGx1 & JTAGEN_OFF ); 

#define SystemFrequency 96000000L / 3 / 1 / 2
#define Timer1Tick ( ( SystemFrequency / 256 ) / Timer1TogglesPerSec )
#define Timer1TogglesPerSec 10
#define Timer3Tick ( ( SystemFrequency / 256 ) / Timer3TogglesPerSec )
#define Timer3TogglesPerSec 100
#define UART2Period ( ( SystemFrequency / UART2Baud ) / 16 ) - 1
#define UART2Baud 19200L

const unsigned char LCMString1[ ] = "PIC24FJ256GB106 ";
const unsigned char LCMString2[ ] = "VR1:    ,Rx:    "; 

unsigned int VR1Value = 0;
volatile unsigned int ADC1Done = 0;

unsigned char UARTString1[ 100 ]; 
volatile unsigned char UART_IsReceived = 0;
volatile unsigned char UART_ReceiveBuffer = 0;
volatile unsigned int T1Done = 0;

void UART_PutROMString( unsigned char * String ); 

// ŧiTimer1_AȨ禡Aëwno_auto_psvC
void __attribute__( ( interrupt , no_auto_psv ) ) _T1Interrupt( void )
{
	static unsigned int T1Tick = 0;

	// MTimer1_XСC
	IFS0bits.T1IF = 0;

	if( ++T1Tick > 9 )
	{
		T1Tick = 0;

		// IO PortA(Toggle)C
		LATDbits.LATD0 = !LATDbits.LATD0;

		T1Done = 1;
	}
}

// wqۤvDefault_AȨ禡Aëwauto_psvC
void __attribute__( ( interrupt , auto_psv ) ) _DefaultInterrupt( void )
{
	while( 1 );
}

// wqStack Error Trap Service RoutineAëwauto_psvC
void __attribute__( ( interrupt , auto_psv ) ) _StackError( void )
{
	while( 1 );
}

// wqADC1_AȨ禡Aëwauto_psvC
void __attribute__( ( interrupt , auto_psv ) ) _ADC1Interrupt( void )
{
	// MADC_X
	IFS0bits.AD1IF = 0;

	// ϥMPLAB C30 ADC FunctionŪADCഫƭ(JVR1ValueܼƤ)C
	VR1Value = ( unsigned int ) ReadADC10( 0 );

	ADC1Done = 1;
}

// To Do : wqUART2 Rereived_AȨ禡Aëwauto_psvC
void __attribute__( ( interrupt , no_auto_psv ) ) _U2RXInterrupt( void )
{
	// MUART2 Rereived_XСC
	IFS1bits.U2RXIF = 0;

	// To Do : ϥC30 UART FunctionŪ쪺(JܼUART_ReceiveBuffer)C
	//		   `N : Bƶ²ϥγ@ܼxsAYyqjɡA
	//		          zLLnUAHKƿ򥢡A
	//		          Ҧp:إߤ@Data QueueӦs񦬨쪺ơC
	UART_ReceiveBuffer = ReadUART2( );

	UART_IsReceived = 1;
}


int main( void )
{
	unsigned char Hours = 0 , Mins = 0 , Secs = 0;
	unsigned char Cursor = 12;

	// ʺAվCPDIV0, CPDIV1CPUu@b32M Hz (Primary Osc. With PLL Mode)
	CLKDIVbits.CPDIV = 0x00;

	// NIO Port]wƦXAëwI/O PortAC
	TRISDbits.TRISD0 = 0;
	LATDbits.LATD0 = 0;

	// LCMlơC
	LCM_Init( );

	// ]wCСAXrC
	LCM_SetCursor( 0 , 0 );
	LCM_PutROMString( LCMString1 );
	LCM_SetCursor( 0 , 1 );
	LCM_PutROMString( LCMString2 );

	// ϥMPLAB C30 Timer FunctionTimer1i]wC
	OpenTimer1( T1_ON & T1_IDLE_CON & T1_GATE_OFF & T1_PS_1_256 & T1_SYNC_EXT_OFF & T1_SOURCE_INT , Timer1Tick );

	// ϥMPLAB C30 Timer FunctionҥTimer1_Aëw䤤_uvC
	ConfigIntTimer1( T1_INT_ON & T1_INT_PRIOR_4 );

	// ϥMPLAB C30 Timer FunctionTimer3i]wC
	// OpenTimer3( ) b v3.31eBug, PR3LkJTƭ, 
	// ]ΪgPR3覡]
	OpenTimer3( T3_ON & T3_GATE_OFF & T3_PS_1_256 & T3_SOURCE_INT , Timer3Tick );
	PR3 = Timer3Tick;

	// ϥΪgȦs覡MPLAB C30 ADC Function]wADCC(אּTIMR3Ĳoഫ)
	OpenADC10_v2( ADC_MODULE_ON & ADC_IDLE_CONTINUE & ADC_FORMAT_INTG & ADC_CLK_TMR3 & 
				  ADC_AUTO_SAMPLING_ON & ADC_SAMP_OFF ,
   				  ADC_VREF_AVDD_AVSS & ADC_SCAN_OFF & ADC_INTR_EACH_CONV &
				  ADC_ALT_BUF_OFF & ADC_ALT_INPUT_OFF ,
				  ADC_SAMPLE_TIME_31 & ADC_CONV_CLK_SYSTEM & ADC_CONV_CLK_64Tcy ,
				  ENABLE_AN2_ANA , 0 ,
				  DISABLE_ALL_INPUT_SCAN , 0 );

	// ϥC30 ADC Function]wADT,tqDC
	SetChanADC10( ADC_CH0_POS_SAMPLEA_AN2 & ADC_CH0_NEG_SAMPLEA_VREFN & 
				  ADC_CH0_POS_SAMPLEB_AN0 & ADC_CH0_NEG_SAMPLEB_VREFN ); 

	// ϥΪgȦs覡MPLAB C30 ADC FunctionҥADC1_Aëw䤤_uvC
	ConfigIntADC10( ADC_INT_ENABLE & ADC_INT_PRI_4 );

	// To Do : ϥC30 PPS FunctionwUART Tx, Rx}C
	//		   `N : ]weOoPPS, ]wAWC
	PPSUnLock;								// __builtin Function
	iPPSInput( IN_FN_PPS_U2RX , IN_PIN_PPS_RP17 );
	iPPSOutput( OUT_PIN_PPS_RP10 , OUT_FN_PPS_U2TX );
	PPSLock;								// __builtin Function

	// To Do : ϥΪgȦs覡MPLAB C30 ADC Function]wUART2C
	OpenUART2( UART_EN & UART_IDLE_CON & UART_EN_WAKE & UART_DIS_LOOPBACK & UART_DIS_ABAUD &
			   UART_NO_PAR_8BIT & UART_1STOPBIT & UART_IrDA_DISABLE & UART_MODE_SIMPLEX &
			   UART_UEN_00 & UART_UXRX_IDLE_ONE & UART_BRGH_SIXTEEN ,
			   UART_INT_TX & UART_IrDA_POL_INV_ZERO & UART_SYNC_BREAK_DISABLED & UART_TX_ENABLE &
			   UART_INT_RX_CHAR & UART_ADR_DETECT_DIS & UART_RX_OVERRUN_CLEAR ,
			   UART2Period );

	// To Do : ϥΪgȦs覡MPLAB C30 UART FunctionҥUART2_Aëw䤤_uvC
	ConfigIntUART2( UART_RX_INT_EN & UART_RX_INT_PR4 & UART_TX_INT_DIS & UART_TX_INT_PR4 ); 

	while( 1 )
	{
		// ഫ ?
		if( ADC1Done )
		{
			ADC1Done = 0;

			// ]wCСAXADCƭȡC
			LCM_SetCursor( 4 , 1 );
			LCM_PutNumber( VR1Value , 4 );
		}

		// UART ?
		if( UART_IsReceived )
		{
			UART_IsReceived = 0;

			// ]wCСAXrC
			LCM_SetCursor( Cursor++ , 1 );
			LCM_PutASCII( UART_ReceiveBuffer );

			if( Cursor > 15 ) Cursor = 12;
		}

		if( T1Done )
		{
			T1Done = 0;

			if( ++Secs > 59 ) 
			{
				Secs = 0;
				if( ++Mins > 59 )
				{
					Mins = 0;
					if( ++Hours > 23 )
						Hours = 0;
				}
			}

			sprintf( ( char * ) UARTString1 , "Now Time : %2d:%2d:%2d\r" ,
					 Hours , Mins , Secs );

 			// ϥΦۭqƱNrzLUARTXC
			UART_PutROMString( UARTString1 );
		}
	}

	while( 1 );
}

void UART_PutROMString( unsigned char * String ) 
{
	while( *String != 0x00 )
	{
		while( BusyUART2( ) );
	    WriteUART2( *String++ );
	}
}
