#include <p24fxxxx.h>
#include <timer.h>
#include <adc.h>
#include "APP026-3_LCM.h"

/* Configuration Settings */
// OSC Input = Primary with PLL , 8M / 2
// Debug Interface PGEC1, PGED1, Disable JTAG
// Disabld WDT, Clock Switch, Fail Safe Clock Monitor ,IO One Way.

// Oscillator ] Primary with PLL Mode, IESO_OFFC
_CONFIG2( POSCMOD_HS & IOL1WAY_OFF & FCKSM_CSDCMD & FNOSC_PRIPLL & PLLDIV_DIV2 & IESO_OFF ); 

// Debug ]Ĥ@, JTAGEN_OFFC
_CONFIG1( WDTPS_PS32768 & FWPSA_PR128 & WINDIS_OFF & FWDTEN_OFF & ICS_PGx1 & JTAGEN_OFF ); 

#define SystemFrequency 96000000L / 3 / 1 / 2
#define Timer1Tick ( ( SystemFrequency / 256 ) / Timer1TogglesPerSec )
#define Timer1TogglesPerSec 10

const unsigned char LCMString1[ ] = "PIC24FJ256GB106 "; 
const unsigned char LCMString2[ ] = "VR1:"; 
unsigned int VR1Value = 0;

// ŧiTimer1_AȨ禡Aëwno_auto_psvC
void __attribute__( ( interrupt , no_auto_psv ) ) _T1Interrupt( void )
{
	// MTimer1_XСC
	IFS0bits.T1IF = 0;

	// To Do : ϥC30 ADC FunctionĲoADCഫC
	Convert????( );

	// IO PortA(Toggle)C
	LATDbits.LATD0 = !LATDbits.LATD0;
}

// wqۤvDefault_AȨ禡Aëwauto_psvC
void __attribute__( ( interrupt , auto_psv ) ) _DefaultInterrupt( void )
{
	while( 1 );
}

// wqStack Error Trap Service RoutineAëwauto_psvC
void __attribute__( ( interrupt , auto_psv ) ) _StackError( void )
{
	while( 1 );
}

int main( void )
{
	// ʺAվCPDIV0, CPDIV1CPUu@b32M Hz (Primary Osc. With PLL Mode)
	CLKDIVbits.CPDIV = 0x00;

	// NIO Port]wƦXAëwI/O PortAC
	TRISDbits.TRISD0 = 0;
	LATDbits.LATD0 = 0;

	// LCMlơC
	LCM_Init( );

	// ]wCСAXrC
	LCM_SetCursor( 0 , 0 );
	LCM_PutROMString( LCMString1 );
	LCM_SetCursor( 0 , 1 );
	LCM_PutROMString( LCMString2 );

	// Timer]wC
	OpenTimer1( T1_ON & T1_IDLE_CON & T1_GATE_OFF & T1_PS_1_256 & T1_SYNC_EXT_OFF & T1_SOURCE_INT , Timer1Tick );

	// ҥTimerAëw䤤_uvC
	ConfigIntTimer1( T1_INT_ON & T1_INT_PRIOR_4 );

	// To Do : ϥΪgȦs覡MPLAB C30 ADC Function]wADCC
	OpenADC10_v2( ADC_MODULE_ON & ADC_IDLE_CONTINUE & ADC_FORMAT_INTG & ADC_CLK_???? & 
				  ADC_AUTO_SAMPLING_???? & ADC_SAMP_OFF ,
   				  ADC_VREF_AVDD_AVSS & ADC_SCAN_???? & ADC_INTR_EACH_CONV &
				  ADC_ALT_BUF_OFF & ADC_ALT_INPUT_OFF ,
				  ADC_SAMPLE_TIME_31 & ADC_CONV_CLK_SYSTEM & ADC_CONV_CLK_64Tcy ,
				  ENABLE_????_ANA , 0 ,
				  DISABLE_ALL_INPUT_SCAN , 0 );

	// To Do : ϥC30 ADC Function]wADT,tqDC
	SetChanADC10( ADC_CH0_POS_SAMPLEA_???? & ADC_CH0_NEG_SAMPLEA_VREFN ); 

	while( 1 )
	{
		// ഫ ?
		if( IFS0bits.AD1IF )
		{
			// To Do : MADC_X
			????

			// To Do : ϥMPLAB C30 ADC FunctionŪADCഫƭ(JVR1ValueܼƤ)C
			VR1Value = ( unsigned int ) ReadADC10( ???? );

			// ]wCСAXADCƭȡC
			LCM_SetCursor( 0 , 1 );
			LCM_PutROMString( LCMString2 );
			LCM_PutNumber( VR1Value , 4 );
		}
	}

	while( 1 );
}
